#include <../../nrnconf.h>
#include <OS/string.h>
#include <InterViews/regexp.h>
#include <stdio.h>
#include "classreg.h"
#include "oc2iv.h"
#include <string.h>

static double l_substr(void*) {
	char* s1 = gargstr(1);
	char* s2 = gargstr(2);
	char* p = strstr(s1, s2);
	if (p) {
		return double(p - s1);
	}else{
		return -1.;
	}
}

static double l_len(void*) {
	return double(strlen(gargstr(1)));
}

static double l_head(void*) {
	String text(gargstr(1));
	Regexp r(gargstr(2));
	r.Search(text.string(), text.length(), 0, text.length());
	int i = r.BeginningOfMatch();
//	text.set_to_left(i); doesnt work
	char** head = hoc_pgargstr(3);
	if (i > 0) {
		char* buf = new char[i+1];
		strncpy(buf, text.string(), i);
		buf[i] = '\0';
		hoc_assign_str(head, buf);
		delete [] buf;
	}else{
		hoc_assign_str(head, "");
	}
	return double(i);
}

static double l_tail(void*) {
	CopyString text(gargstr(1));
	Regexp r(gargstr(2));
	r.Search(text.string(), text.length(), 0, text.length());
	int i = r.EndOfMatch();
	char** tail = hoc_pgargstr(3);
	if (i >= 0) {
		hoc_assign_str(tail, text.string() + i);
	}else{
		hoc_assign_str(tail, "");
	}
	return double(i);
}

static double l_left(void*) {
	CopyString text(gargstr(1));
	CopyString newtext = text.left(int(chkarg(2,0,strlen(gargstr(1)))));
	hoc_assign_str(hoc_pgargstr(1), newtext.string());
	return 1.;
}

static double l_right(void*) {
	CopyString text(gargstr(1));
	CopyString newtext = text.right(int(chkarg(2,0,strlen(gargstr(1)))));
	hoc_assign_str(hoc_pgargstr(1), newtext.string());
	return 1.;
}

static double l_is_name(void*) {
	return hoc_lookup(gargstr(1)) ? 1. : 0.;
}

static Member_func l_members[] = {
	"substr", l_substr,
	"len", l_len,
	"head", l_head,
	"tail", l_tail,
	"right", l_right,
	"left", l_left,
	"is_name", l_is_name,
	0,0
};

static void* l_cons(Object*) {
	return nil;
}

static void l_destruct(void*) {
}

void StringFunctions_reg() {
	class2oc("StringFunctions", l_cons, l_destruct, l_members);
}

