#ifdef HAVE_CONFIG_H
#include <../../config.h>
#endif
/*
 * Copyright (c) 1987, 1988, 1989, 1990, 1991 Stanford University
 * Copyright (c) 1991 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Stanford and Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Stanford and Silicon Graphics.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL STANFORD OR SILICON GRAPHICS BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include <OS/memory.h>
#if !defined(WIN32) && !MAC
#include <unistd.h>
#endif
#include <string.h>

void Memory::copy(const void* from, void* to, unsigned int nbytes) {
#if MAC
	BlockMove(from, to, nbytes);
#elif defined(STDC_HEADERS) // ANSI C memmove and memset:
    memmove(to, from, size_t(nbytes));
#elif defined(HAVE_BCOPY)
    bcopy(from, to, nbytes);
#else
#error "Neither bcopy nor mmove is defined."
#endif
}

int Memory::compare(const void* b1, const void* b2, unsigned int nbytes) {
    return memcmp(b1, b2, nbytes) != 0;
}

void Memory::zero(void* b, unsigned int nbytes) {
    memset(b, 0, size_t(nbytes));
}
