#!/bin/sh

if test "$NVER" = "" ; then
	NVER=`"$HOME/neuron/nrn/nrnversion.sh"`
	echo "NVER not set, using $NVER"
fi

NDIR="NEURON-$NVER"
export NDIR
N="/Applications/$NDIR/nrn"

# activate macnrn.term and the app bundles
osascript -e 'tell application "Finder"'\
 -e 'activate'\
 -e 'make new Finder window'\
 -e 'set target of Finder window 1 to folder "'$NDIR'" of folder "Applications" of startup disk'\
 -e 'set target of Finder window 1 to folder "bin" of folder "powerpc" of folder "nrn" of folder "'$NDIR'" of folder "Applications" of startup disk'\
 -e 'end tell'

#strip the dylibs
cd ${N}/powerpc/lib
for i in *.dylib ; do
	if test ! -L $i ; then
		strip -x $i
	fi
done



#remove irrelevant executables
cd ${N}/powerpc/bin
rm -f hoc_e ivoc mos2nrn nrnoc oc

# and strip the others
for i in memacs modlunit nocmodl nrniv ; do
	strip -x $i
done

# force rebuild of the neurondemo and clean it up
DEMO="${N}/share/nrn/demo"
rm -f -r ${DEMO}/neuron ${DEMO}/release/powerpc
./neurondemo << here
quit()
here
if cd ${N}/share/nrn/demo/release/powerpc ; then
	rm -f *.o *.c *.lo *.mod
	cd .libs
	rm -f *.o
	for i in *.so ; do
		if test ! -L $i ; then
			strip -x $i
		fi
	done
fi



# only after an iv installation
if test "$1" = "iv" ; then
	cd ${N}/../iv/powerpc/lib
	for i in *.dylib ; do
		if test ! -L $i ; then
			strip -x $i
		fi
	done
	cd ../bin
	rm -f iclass idemo
	strip -x idraw
fi
