#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef CYGWIN
#include <unistd.h>
#undef WIN32
#define WIN32
#define boolean int
#endif

static void nrnzipfile(const char*);
char* back2forward(const char*);
const char* basefile(const char*);
extern "C" {
int printf(const char*, ...) {return 0;}
void HandleOutput(const char*) {}
}

char* nrnhome;
const char* nh;

static void setneuronhome() {
	int i, j;
	char buf[256];
	GetModuleFileName(NULL, buf, 256);
	for (i=strlen(buf); i >= 0 && buf[i] != '\\'; --i) {;}
	buf[i] = '\0'; // /neuron.exe gone
	for (i=strlen(buf); i >= 0 && buf[i] != '\\'; --i) {;}
	buf[i] = '\0'; // /bin gone
	nrnhome = new char[strlen(buf)+1];
	strcpy(nrnhome, buf);
}

char* back2forward(const char* back) {
	char *forward;
	char *cp;
   	forward = new char[strlen(back) + 1];
		strcpy(forward, back);
		for (cp = forward; *cp; ++cp) {
			if (*cp == '\\') {
				*cp = '/';
			}
		}
	return forward;
}

int main(int argc, char** argv) {
	char buf[256];

	if (argc != 2 ) {
		MessageBox(0, "Usage: mos2nrn nrnzipfile", "mos2nrn", MB_OK);
		return 1;
	}
#if 0
	sprintf(buf, "arg 1 = |%s|", argv[1]);
	MessageBox(0, buf, "mos2nrn", MB_OK);
#endif
	setneuronhome();
	nh = back2forward(nrnhome);
	//sprintf(buf, "NEURONHOME=|%s|", nrnhome);
	//MessageBox(NULL, buf, "mos2nrn", MB_OK);
	FILE* f = fopen(argv[1], "r");
	if (!f) {
		return 1;
	}
	fread(buf, 1, 5, f);
	fclose(f);
	if (strncmp(buf, "PK", 2) == 0) { // its a nrnzip file
			nrnzipfile(argv[1]);
	}else{ // its a hoc file
		sprintf(buf, "%s is not a zip file", argv[1]);
		MessageBox(0, buf, "mos2nrn", MB_OK);
	}
	return 0;
}


const char* basefile(const char* path) {
	const char* cp;
	for (cp = path + strlen(path) - 1; cp >= path; --cp) {
		if (*cp == '\\' || *cp == ':') {
			return cp+1;
		}
	}
	return path;
}

static void diag(const char* s1, const char* s2){
	char buf[256];
	sprintf(buf, "nrnzip error: %s %s", s1, s2);
	MessageBox(0, buf, "mos2nrn", MB_OK);
}

int system(char* s) {
	DWORD exitcode;
	PROCESS_INFORMATION pinfo;
	STARTUPINFO st;
	HANDLE val;
	//MessageBox(NULL, s, "system...", MB_OK);

        st.cb               = sizeof (STARTUPINFO);
        st.lpReserved       = 0;
        st.lpDesktop        = 0;
        st.lpTitle          = 0;
        st.dwX              = 0;
        st.dwY              = 0;
        st.dwXSize          = 0;
        st.dwYSize          = 0;
        st.dwXCountChars    = 0;
        st.dwYCountChars    = 0;
        st.dwFillAttribute  = 0;
		  st.dwFlags          = 0;
        st.wShowWindow      = 0;
        st.cbReserved2      = 0;
        st.lpReserved2      = 0;

	if (! CreateProcess(0, s, 0, 0, FALSE,
	  /*CREATE_NEW_CONSOLE,*/ 0,
	  0, 0, &st, &pinfo)) {
		MessageBox(0, s, "CreateProcess failed for:", MB_OK);
		return 1;
	}
	val = pinfo.hProcess;
//	printf("val = %d\n", val);
//	printf("CreateProcess handle = %x\n", pinfo.hProcess);
//	printf("CreateProcess id = %x\n", pinfo.dwProcessId);

	do {
		Sleep(0);
		if (!GetExitCodeProcess(val, &exitcode)) {
//			printf("GetExitCodeProcess failed\n");
		}
//		printf("exitcode=%d\n", exitcode);
	} while (exitcode == STILL_ACTIVE);

	CloseHandle(pinfo.hProcess);
	CloseHandle(pinfo.hThread);
	return exitcode;
}

static void nrnzipfile(const char* name) {
	char d_orig[256];
	char s[256];
	char buf[256];
	char fname[256];
	int cancel = 0;
	int moslocal_ = 0;
#ifdef CYGWIN
	char tdir[256];
	GetTempPath(255, tdir);
	char* dname;
	dname = tempnam(tdir, "nrn");
#else
	char* tdir;
	if ((tdir = getenv("TEMP")) == NULL) {
		diag("No TEMP environment variable", 0);
		return;
	}
	char dname[256];
	//sprintf(dname, "%s\\nrnXXXXXX", tdir);
	//mktemp(dname);
	char* tnam = tmpnam(0);
	sprintf(dname, "%s\\%s", tdir, tnam);
#endif
	if (!CreateDirectory(dname, 0)) {
		diag("Couldn't create directory:", dname);
		return;
	}
	sprintf(fname, "%s\\nrnzip.zip", dname);
	if (!CopyFile(name, fname, TRUE)) {
		diag("Couldn't copy nrnzip file to:", fname);
		return;
	}
	GetCurrentDirectory(256, d_orig);
	if (!SetCurrentDirectory(dname)) {
		diag("Couldn't set current directory to:", dname);
		return;
	}
	sprintf(buf, "%s\\bin\\sh %s/lib/mos2nrn.sh %s", nrnhome, nh, nh);
	system(buf);

	SetCurrentDirectory(tdir); // otherwise can't delete
	SetCurrentDirectory(d_orig);
	sprintf(buf, "NEURON for \"%s\" has been closed. Press \
the \"yes\" button if you wish to remove this directory.",
dname);
	if (moslocal_
		|| MessageBox(0, buf, "mos2nrn", MB_YESNO | MB_DEFBUTTON2) == IDYES) {
		sprintf(buf, "rm -r -f %s",back2forward(dname));
		WinExec(buf, SW_SHOW);
	}
}

