#include <../../nrnconf.h>
/* /local/src/master/nrn/src/nmodl/consist.c,v 4.1 1997/08/30 20:45:15 hines Exp */
/*
consist.c,v
 * Revision 4.1  1997/08/30  20:45:15  hines
 * cvs problem with branches. Latest nmodl stuff should now be a top level
 *
 * Revision 4.0.1.1  1997/08/08  17:23:38  hines
 * nocmodl version 4.0.1
 *
 * Revision 4.0  1997/08/08  17:06:02  hines
 * proper nocmodl version number
 *
 * Revision 1.2  1995/09/05  20:36:21  hines
 * paramete array allowd
 * limits syntax changed to <...>
 *
 * Revision 1.1.1.1  1994/10/12  17:21:34  hines
 * NEURON 3.0 distribution
 *
 * Revision 9.64  90/11/26  08:15:39  hines
 * external functions of type EXTDEF3 get two extra arguments.
 * The first arg is a pointer to _reset which should be set by the
 * function upon the occurence of a discontinuity.
 * The second arg is a pointer to a double which may be used by the
 * function to store information to help determine if a discontinuity
 * has occurred.  init.c gives a list of these functions.
 * 
 * Revision 9.58  90/11/20  17:23:20  hines
 * CONSTANT changed to PARAMETER
 * CONSTANT now refers to variables that don't get put in .var file
 * 
 * Revision 9.52  90/11/10  15:44:12  hines
 * nmodl: uses new NEURON { USEION ... format
 * passive.c works
 * 
 * Revision 9.50  90/11/02  08:29:53  hines
 * Allow UNITS block and make a  units defintion scale factor a static
 * variable so that it doesn't have to appear in the var file. eg.
 * UNITS { FARADAY = 96520 (coul) }
 * 
 * Revision 9.29  90/09/10  14:07:54  hines
 * certain functions specified in extdef2.h can have arguments which are
 * pointers to functions and pointers to vectors.
 * 
 * Revision 9.28  90/09/09  17:28:04  hines
 * merge the summer's work at nbsr into modl
 * 
 * Revision 9.10  90/07/27  13:57:33  hines
 * nmodl handles declarations about right for first pass at this.
 *
 * Revision 8.1  90/08/03  14:26:24  mdf
 * Consistency message DEPENDENT changed to ASSIGNED.
 * Use of external definition and other reserved variables gets message
 * RESERVED WORD.
 * 
 * Revision 8.0  89/09/22  17:25:59  nfh
 * Freezing
 * 
 * Revision 7.1  89/09/07  07:36:53  mlh
 * a scop independent variable may be a constant and an independent
 * if it is not the same as the model independent variable
 * 
 * Revision 7.0  89/08/30  13:31:24  nfh
 * Rev 7 is now Experimental; Rev 6 is Testing
 * 
 * Revision 6.0  89/08/14  16:26:10  nfh
 * Rev 6.0 is latest of 4.x; now the Experimental version
 * 
 * Revision 4.0  89/07/24  17:02:37  nfh
 * Freezing rev 3.  Rev 4 is now Experimental
 * 
 * Revision 3.1  89/07/07  16:46:31  mlh
 * FIRST LAST START in independent SWEEP higher order derivatives
 * 
 * Revision 1.1  89/07/06  14:47:08  mlh
 * Initial revision
 * 
*/

/*
 * Check that names do not have conflicting types.  This is done after the
 * entire file is read in and allows declaring a variable after its use (very
 * bad style) to work in some circumstances. 
 */
#include "modl.h"
#include "parse1.h"
#include "symbol.h"

extern Symbol *scop_indep;
extern Symbol *indepsym;

#define con(arg1,arg2,arg3) if (t & (arg2)) if (t & (~(arg2 | arg3))) {\
			Fprintf(stderr, "%s is a %s\n",\
				s->name, arg1);\
			err=1;\
		}

consistency()
{
	Symbol         *s;
	Item           *qs;
	int             i, tu, err = 0;
	long            t;


	/* the scop_indep can also be a automatic parameter */
	if (scop_indep != indepsym && scop_indep->subtype == PARM | INDEP) {
		scop_indep->subtype = INDEP;
	}
	
	SYMITER(NAME) {
		t = s->subtype;
		con("KEYWORD", KEYWORD, 0);
		con("RESERVED WORD", EXTDEF|EXTDEF2|EXTDEF3, 0);
		con("CONSTANT", CONST, 0);
		con("PARAMETER", PARM, ARRAY);
		con("ASSIGNED", DEP, ARRAY);
		con("INDEPENDENT", INDEP, 0);
		con("STATE", STAT, ARRAY);
		con("FUNCTION", FUNCT, 0);
		con("PROCEDURE", PROCED, 0);
		con("DERIVATIVE", DERF, 0);
		con(" KINETIC", KINF, 0);
		con("LINEAR", LINF, 0);
		con("NONLINEAR", NLINF, 0);
		con("DISCRETE", DISCF, 0);
		con("PARTIAL", PARF, 0);
		con("STEPPED", STEP1, 0);
		con("CONSTANT UNITS FACTOR", UNITDEF, 0);
		tu = s->usage;
		if ((tu & DEP) && (tu & FUNCT))
			diag(s->name, " used as both variable and function");
		if ((t == 0) && tu)
			Fprintf(stderr,
				"Warning: %s undefined. (declared within VERBATIM?)\n", s->name);
	}
	if (err) {
		diag("multiple uses for same variable", (char *) 0);
	}
	if (indepsym == SYM0) {
		diag("Independent variable is not defined", (char *)0);
	}
}
