#include <../../nrnconf.h>
#include	<stdio.h>
#include	<errno.h>
#include	<math.h>
#include	<InterViews/resource.h>
#include	"nrnoc2iv.h"
#include	"cvodeobj.h"


typedef int (*Pfridot)(...);
extern "C" {

#include	"membfunc.h"
#include	"neuron.h"
#include	"spmatrix.h"

extern int	diam_changed;
extern int	tree_changed;
extern char* secname(Section*);
extern void recalc_diam();
extern int nrn_errno_check(int);
extern void activstim(), activclamp(), activsynapse();

extern void nrn_setup_ext(); // here for temporary testing
}

void Cvode::daspk_setup1_tree_matrix() /* construct diagonal elements */
{
#if 0
	int i;

	if (diam_changed) {
		recalc_diam();
	}
	if (use_sparse13) {
		int i, neqn;
		neqn = spGetSize(sp13mat_, 0);
		spClear(sp13mat_);
		for (i=1; i <= neqn; ++i) {
			sp13rhs_[i] = 0.;
		}
	}else{
		for (i = 0; i < v_node_count_; ++i) {
			NODERHS(v_node_[i]) = 0.;
			NODED(v_node_[i]) = 0.;
		}
	}
	CvMembList* cml;
	for (cml = cv_memb_list_; cml; cml = cml->next) {
		int j, count;
		Memb_func* mf = memb_func + cml->index;
		if (mf->current) {
			Pfridot s = (Pfridot)mf->current;
			if (mf->vectorized) {
				if (cml->index != CAP) (*s)(
				   cml->nodecount,
				   cml->nodelist,
				   cml->data,
				   cml->pdata,
				   cml->index
				);
			}else if (mf->hoc_mech) {
				count = cml->nodecount;
				for (j = 0; j < count; ++j) {
					(*s)(cml->nodelist[j], cml->prop[j]);
				}
			}else{
				count = cml->nodecount;
				for (j = 0; j < count; ++j) {
					Node* nd = cml->nodelist[j];
					(*s)(nd, cml->data[j], cml->pdata[j]);
				};
			}
			if (errno) {
				if (nrn_errno_check(cml->index)) {
hoc_warning("errno set during calculation of currents", (char*)0);
				}
			}
		}
	}
	activsynapse();
#if SEJNOWSKI
	activconnect();
#endif

#if EXTRACELLULAR
	// valid here only for xcm=0. Using for testing the basic strategy.
	// must be before activstim and activclamp (which are obsolete anyway)
	nrn_setup_ext();
#endif
	activstim();
	activclamp();

	/* at this point d contains all the membrane conductances */
	// but not capacitance
#if 0
printf("end of daspk_setup1_tree_matrix\n");
for (i=0; i < v_node_count; ++i) {
	printf("i=%d d=%g v=%g rhs=%g\n", i, 
	NODED(v_node_[i]), v_node_[i]->v, NODERHS(v_node_[i]));
}
#endif
#endif
}

void Cvode::daspk_setup2_tree_matrix() {
#if 0
	int i;

	/* now add the axial currents */

	for (i=0; i < v_node_count_; ++i) {
		Node* nd = v_node_[i];
		NODERHS(nd) += NODEB(nd) * (nd->v - v_parent_[i]->v)
			- NODED(nd) * nd->v;
	}

	if (use_sparse13) {
		for (i = rootnodecount; i < v_node_count; ++i) {
			Node* nd = v_node[i];
			*(nd->_a_matelm) += NODEA(nd);
			*(nd->_b_matelm) += NODEB(nd);
			NODED(nd) -= NODEB(nd);
		}
	}else{
		for (i = 0; i < v_node_count_; ++i) {
			NODED(v_node_[i]) -= NODEB(v_node_[i]);
		}
	}

        for (i=1; i < v_node_count_; ++i) {
                NODED(v_parent_[i]) -= NODEA(v_node_[i]);
        }

	for (i=1; i < v_node_count_; ++i) {
		Node* nd = v_node_[i], *pnd = v_parent_[i];
		NODERHS(pnd) += NODEA(nd) * (pnd->v - nd->v);
	}
#if 0
printf("end of daspk_setup2_tree_matrix\n");
for (i=0; i < v_node_count; ++i) {
	printf("i=%d b=%g d=%g a=%g rhs=%g\n", i, 
	NODEB(v_node_[i]), NODED(v_node_[i]), NODEA(v_node_[i]), NODERHS(v_node_[i]));
}
#endif
#endif
}
