#ifndef bbs_h
#define bbs_h

#include "bbsimpl.h"

class BBS {
public:
	BBS();
	BBS(int nhost);
	virtual ~BBS();

	boolean look(const char*);

	void take(const char*); /* blocks til something to take */
	boolean look_take(const char*); /* returns false if nothing to take */
	// after taking use these
	int upkint();
	double upkdouble();
	void upkvec(int n, double* px); // n input px space must exist
	char* upkstr(); // delete [] char* when finished

	// before posting use these
	void pkbegin();
	void pkint(int);
	void pkdouble(double);
	void pkvec(int n, double* px); // doesn't pack n
	void pkstr(const char*);
	void post(const char*);

	int submit(int userid);
	boolean working(int &id, double& x, int& userid);
	void context();

	boolean is_master();
	void worker(); // forever execute
	void done(); // prints timing

	void perror(const char*);
	double time();

	int nhost();
protected:
	void init(int);
protected:
	BBSImpl* impl_;
};

#endif
